local DAMAGE_S = settings.startup["cb-DamageScaler"].value

local replaces = {
	['small-cold-worm-turret']={'small-worm-turret'},
	['medium-cold-worm-turret']={'medium-worm-turret'},
	['big-cold-worm-turret']={'big-worm-turret'},
	['behemoth-cold-worm-turret']={'behemoth-worm-turret'},
	['leviathan-cold-worm-turret']={'behemoth-worm-turret'},
	['mother-cold-worm-turret']={'behemoth-worm-turret'},
	['cb-cold-spawner']={'biter-spawner','spitter-spawner'},
	}
	
function square_area( origin, radius )
	return {
		{x=origin.x - radius, y=origin.y - radius},
		{x=origin.x + radius, y=origin.y + radius}
	}
end

script.on_event(defines.events.on_entity_died, function(event)
local ent = event.entity
if ent.name == 'small-cold-biter' or 
   ent.name == 'medium-cold-biter' or
   ent.name == 'big-cold-biter' or
   ent.name == 'behemoth-cold-biter' or
   ent.name == 'leviathan-cold-biter' or 
   ent.name == 'small-cold-spitter' or 
   ent.name == 'medium-cold-spitter' or 
   ent.name == 'big-cold-spitter' or 
   ent.name == 'behemoth-cold-spitter' or 
   ent.name == 'leviathan-cold-spitter' or 
   ent.name == 'cb-cold-spawner' or 
   ent.name == 'mother-cold-spitter' or
   ent.name == 'small-cold-worm-turret' or
   ent.name == 'medium-cold-worm-turret' or
   ent.name == 'big-cold-worm-turret' or
   ent.name == 'behemoth-cold-worm-turret' or
   ent.name == 'leviathan-cold-worm-turret' or
   ent.name == 'mother-cold-worm-turret' then 


	
local force = ent.force
   
   local size = 3
   local expl = 'big-cold-explosion'
   local cloud = 'cold-cloud-1'
   if string.find(ent.name, 'small')~= nil or string.find(ent.name,'medium')~= nil then 
		expl = 'cold-explosion'
		size = 2
		elseif string.find(ent.name,'leviathan')~= nil or string.find(ent.name,'mother')~= nil then 
		expl = 'big-artillery-cold-explosion'
		cloud = 'cold-cloud-2' 
		size = 4
		end
   
    local damage = math.floor (50 * DAMAGE_S * (1+ (2* force.evolution_factor)))
	ent.surface.create_entity{name=expl, position=ent.position, force}
	ent.surface.create_entity{name=cloud, position=ent.position, force}

	local a = square_area(ent.position,size)
		local ents = ent.surface.find_entities(a)
			for _, ent in pairs(ents) do
				if ent.valid and ent.health ~= nil then
				ent.damage(damage,force,"cold")
				end
			end


	if string.find(ent.name, 'leviathan') or string.find(ent.name,'mother')~= nil then
	ent.surface.create_entity{name="small-atomic-cold-explosion", position=ent.position, force}
	elseif ent.name == 'cb-cold-spawner' then
	  if math.random(1,3)==1 then 
	   ent.surface.create_entity{name="small-atomic-cold-explosion", position=ent.position, force} 
	  end
	end
	
	
	end
end)


local function GetLocalTemperature(surface,position)
local temperature
local calc = surface.calculate_tile_properties({'temperature'},{position}) 
if calc and calc.temperature then
	temperature = calc.temperature[1] end
return temperature
end

script.on_event(defines.events.on_biter_base_built, function(event)
if not settings.startup["cb-disable-temperature-check"].value then


local entity=event.entity
if replaces[entity.name] then
	local position=entity.position
	local surface=entity.surface
	local force=entity.force
	local temperature = GetLocalTemperature(surface,position) 
	if temperature then 
		if temperature > global.temp_max or temperature < global.temp_min then
			local name   = entity.name
			local replac = replaces[name][math.random(#replaces[name])]
			entity.destroy()
			surface.create_entity{name=replac, position=position, force=force} 
			end
		end
	end
	
end
end)


local function SetTemperatures()
global.temp_min = 0
global.temp_max = 25
if game.tile_prototypes['frozen-snow-1'] then 
	global.temp_min=-50 
	global.temp_max=10  --frozen areas
	end
end


local function on_configuration_changed(data)
SetTemperatures()
end

local function on_init()
SetTemperatures()
end

script.on_configuration_changed(on_configuration_changed)
script.on_init(on_init)
