local DAMAGE_S = settings.startup["eb-DamageScaler"].value

local replaces = {
	['small-explosive-worm-turret']={'small-worm-turret'},
	['medium-explosive-worm-turret']={'medium-worm-turret'},
	['big-explosive-worm-turret']={'big-worm-turret'},
	['behemoth-explosive-worm-turret']={'behemoth-worm-turret'},
	['leviathan-explosive-worm-turret']={'behemoth-worm-turret'},
	['mother-explosive-worm-turret']={'behemoth-worm-turret'},
	['explosive-biter-spawner']={'biter-spawner','spitter-spawner'},
	}
	

function square_area( origin, radius )
	return {
		{x=origin.x - radius, y=origin.y - radius},
		{x=origin.x + radius, y=origin.y + radius}
	}
end

script.on_event(defines.events.on_entity_died, function(event)

local ent = event.entity
if ent.name == 'small-explosive-biter' or 
   ent.name == 'medium-explosive-biter' or
   ent.name == 'big-explosive-biter' or
   ent.name == 'behemoth-explosive-biter' or
   ent.name == 'explosive-leviathan-biter' or 
   ent.name == 'small-explosive-spitter' or 
   ent.name == 'medium-explosive-spitter' or 
   ent.name == 'big-explosive-spitter' or 
   ent.name == 'behemoth-explosive-spitter' or 
   ent.name == 'leviathan-explosive-spitter' or 
   ent.name == 'explosive-biter-spawner' or 
   ent.name == 'mother-explosive-spitter' or
   ent.name == 'small-explosive-worm-turret' or
   ent.name == 'medium-explosive-worm-turret' or
   ent.name == 'big-explosive-worm-turret' or
   ent.name == 'behemoth-explosive-worm-turret' or
   ent.name == 'leviathan-explosive-worm-turret' or
   ent.name == 'mother-explosive-worm-turret' then 

local force = ent.force
   
   local size = 3
   local expl = 'big-explosion'
   if string.find(ent.name, 'small')~= nil or string.find(ent.name,'medium')~= nil then 
		expl = 'explosion'
		size = 2
		elseif string.find(ent.name,'leviathan')~= nil or string.find(ent.name,'mother')~= nil then 
		expl = 'big-artillery-explosion'
		size = 4
		end
   
    local damage = math.floor (50 * DAMAGE_S * (1+ (2* force.evolution_factor)))
	ent.surface.create_entity{name=expl, position=ent.position, force}
	ent.surface.create_entity{name="explosive-biter-flame", position=ent.position, force}
	
	local a = square_area(ent.position,size)
		local ents = ent.surface.find_entities(a)
			for _, ent in pairs(ents) do
				if ent.valid and ent.health ~= nil then
				ent.damage(damage,force,"explosion")
				end
			end


	if string.find(ent.name, 'leviathan') or string.find(ent.name,'mother')~= nil then
	ent.surface.create_entity{name="small-atomic-explosion", position=ent.position, force}
	elseif ent.name == 'explosive-biter-spawner' then
	  if math.random(1,3)==1 then 
	   ent.surface.create_entity{name="small-atomic-explosion", position=ent.position, force} 
	  end
	end
			
	end
	

end)



local function GetLocalTemperature(surface,position)
local temperature
local calc = surface.calculate_tile_properties({'temperature'},{position}) 
if calc and calc.temperature then
	temperature = calc.temperature[1] end
return temperature
end


script.on_event(defines.events.on_biter_base_built, function(event)
if not settings.startup["eb-disable-temperature-check"].value then
local entity=event.entity
if replaces[entity.name] then
	local position=entity.position
	local surface=entity.surface
	local force=entity.force
	local temperature = GetLocalTemperature(surface,position) 
	if temperature then 
		if temperature > global.temp_max or temperature < global.temp_min then
			local name   = entity.name
			local replac = replaces[name][math.random(#replaces[name])]
			entity.destroy()
			surface.create_entity{name=replac, position=position, force=force} 
			end
		end
	end
end
end)


local function SetTemperatures()
global.temp_min = 20
global.temp_max = 60
if game.tile_prototypes['frozen-snow-1'] then 
	global.temp_min=50 
	global.temp_max=150  --volcanic areas
	end
end


local function on_configuration_changed(data)
SetTemperatures()
end

local function on_init()
SetTemperatures()
end

script.on_configuration_changed(on_configuration_changed)
script.on_init(on_init)
